#!/usr/bin/env python
# Created: Chandra Sekhar Pedamallu, DFCI, The Broad Inst.
# Purpose: mapper jobs for Maq alignments
# Notes: S3 bucket is not available for this version
# Updates: Removed Quality Filter
#          Added duplicate remover at the begining 
# DFCI @ copyright

import sys
import os
import commands
import random

#input comes from STDIN
for line in sys.stdin:
	hadooploc="/usr/local/hadoop-1.0.3"
	
        # Strip off spaces infornt and behing the lines
        line = line.strip()
        print line
        tokens=line.split("/")
        name1=""
        for token in tokens:
                name1=token
        print name1
        tokens1=name1.split(".")
        print tokens1
        j=0
        for token in tokens1:
                j=j+1

        print j
        j=j-1
        j1=0
        name=""
        for token in tokens1:
                if j1==0:
                        name=name + token
                elif j1==j:
                        print "test"
                else:
                        name=name + "."
                        name=name + token
                j1=j1+1

        print name
	# config file download
	nconfignum=random.randint(0, 1000000)
	nconfig=str(nconfignum)

        # Download config file from hadoop file system 
	wget1=hadooploc + "/bin/hadoop fs -get /user/root/config/config /usr/local/" 
	wget1=wget1 + nconfig
        wget=commands.getstatusoutput(wget1)
        print wget
        
	# Download maq database file from hadoop file system 
	wget1=hadooploc + "/bin/hadoop fs -get /user/root/config/premaq.db /usr/local/" 
	wget1= wget1+ nconfig
	wget1= wget1 + ".premaq.db"
        wget=commands.getstatusoutput(wget1)
        print wget
	
	# Download maq database file from hadoop file system 
	wget1=hadooploc + "/bin/hadoop fs -get /user/root/config/maq.db /usr/local/" 
	wget1= wget1 + nconfig
	wget1= wget1 + ".maq.db"
        wget=commands.getstatusoutput(wget1)
        print wget
	
	# Download bwa database file from hadoop file system 
	wget1=hadooploc + "/bin/hadoop fs -get /user/root/config/bwa.db /usr/local/" 
	wget1= wget1 + nconfig
	wget1= wget1 + ".bwa.db"
        wget=commands.getstatusoutput(wget1)
        print wget

        # read config file from hadoop file system 
	output=""
	stat=""
	namefile="/usr/local/" + nconfig
	ff = open(namefile, 'r')
	data = ff.readlines()
	output=data[0].strip()
        stat=data[1].strip()
	ff.close()

	# Maq alignment database
	name_fi="/usr/local/" + nconfig
	name_fi=name_fi + ".maq.db"
	ff = open(name_fi, 'r')
	database = ff.readlines()
	ff.close()
	no_databases=len(database)
	
	# BWA alignment database
	name_fi="/usr/local/" + nconfig
	name_fi=name_fi + ".bwa.db"
	ff = open(name_fi, 'r')
	bwadatabase = ff.readlines()
	ff.close()
	no_bwadatabases=len(bwadatabase)
	
	# Pre-Maq alignment database
	name_fi="/usr/local/" + nconfig
	name_fi=name_fi + ".premaq.db"
	ff = open(name_fi, 'r')
	predatabase = ff.readlines()
	ff.close()
	no_predatabases=len(predatabase)


        # Wget the SAM files from FTP server
	wget1="/usr/bin/s3cmd -f -c /root/.s3cfg get -r " + line
	wget1=wget1 + " /mnt/mfiles/reads/"
        wget=commands.getstatusoutput(wget1)
        print wget
        print "\n"
        
	# Wget the SAM files from FTP server
	wget1="/bin/gunzip /mnt/mfiles/reads/" + name1
        wget=commands.getstatusoutput(wget1)
        print wget
        print "\n"

        #File names
        fFASTQ=name
        fSAM=name + ".sam"
        fQSAM=fSAM + ".sam"
        fFQ1=name + ".fq1"
        fBFQ=name + ".bfq"
        fUmap=name + ".nr"
        fOut=name + ".out"
	fDUP1=name + ".dup"
	fDUP=fDUP1 + ".fq1"
        fSORT1=name + ".sorted"
        fSORT=fSORT1 + ".fq1"	
	fFASTA=name + ".fasta"
	fOUT=name + ".out"
	fOUT1=name + ".out1"
	fFQ2=name + ".u.fq1"

	# filenames of statistics
        sINT=name + ".stat.int"
        sDUP=name + ".stat.dup"
        sDB=name + ".stat.mdb"
        bDB=name + ".stat.bdb"
	sPreMaq=name + ".stat.premaq"

	#Duplicate remover
        #Step 1: Duplicate remover
        #Step 1a. Convert FASTQ2FQ1 - Compile Java file
        FASTQ2FQ1="/usr/local/jdk1.6.0_21/bin/javac -classpath . "
        FASTQ2FQ1=FASTQ2FQ1 + "Fastq2FQone.java"
        FASTQ2FQ1c=commands.getstatusoutput(FASTQ2FQ1)
        print FASTQ2FQ1c

        #Step1b. Convert FASTQ2FQ1
        FASTQ2FQ1="/usr/local/jdk1.6.0_21/bin/java -classpath . Fastq2FQone /mnt/mfiles/reads/" + fFASTQ
        FASTQ2FQ1=FASTQ2FQ1 + " /mnt/mfiles/reads/"
        FASTQ2FQ1=FASTQ2FQ1 + fFQ1
        FASTQ2FQ1c=commands.getstatusoutput(FASTQ2FQ1);
        print FASTQ2FQ1c

        #Step1c. Sorting the FQ1 file
	print "SORTING"
	SORT1="/bin/sort +1 -2 -T /mnt/mfiles /mnt/mfiles/reads/" + fFQ1
        SORT1=SORT1 + " > /mnt/mfiles/reads/"
        SORT1=SORT1 + fSORT
        SORT=commands.getstatusoutput(SORT1);
        print SORT
        
	#Before Duplicate remover - STATISTICS
	print "Statistics before duplicate remover"
	STAT1="/usr/bin/wc -l /mnt/mfiles/reads/" + fSORT
	STAT1=STAT1 + " > /mnt/mfiles/reads/"
	STAT1=STAT1 + sINT
        STAT=commands.getstatusoutput(STAT1);
        print STAT
        
	#Upload the Statistics of reads before duplicate remover
        out1="/usr/bin/s3cmd -f -c /root/.s3cfg put /mnt/mfiles/reads/" + sINT
        out1=out1 + " s3://"
	out1=out1 + stat
	out1=out1 + "/"
        print out1
        out=commands.getstatusoutput(out1)
	
	#Step1d. Duplicate remover
	DUP1="/usr/local/jdk1.6.0_21/bin/javac -classpath . "
	DUP1=DUP1 + "*.java"
	DUP=commands.getstatusoutput(DUP1);
	print DUP

	#Step1e. Run duplicate remover
	DUP1="/usr/local/jdk1.6.0_21/bin/java -classpath . removeduplicates_new /mnt/mfiles/reads/" + fSORT
	DUP1=DUP1 + " /mnt/mfiles/reads/"
	DUP1=DUP1 + fFQ1
	print DUP1
	DUP=commands.getstatusoutput(DUP1);
	print DUP
	print "completed"
	
        #STATISTICS - AFTER DUPLICATE REMOVER
        STAT1="/usr/bin/wc -l /mnt/mfiles/reads/" + fFQ1
	STAT1=STAT1 + " > /mnt/mfiles/reads/"
	STAT1=STAT1 + sDUP
        STAT=commands.getstatusoutput(STAT1);
        print STAT

	#Upload the Statistics of reads after duplicate remover
        out1="/usr/bin/s3cmd -f -c /root/.s3cfg put /mnt/mfiles/reads/" + sDUP
        out1=out1 + " s3://"
	out1=out1 + stat
	out1=out1 + "/"
        print out1
        out=commands.getstatusoutput(out1)
       

############Running Pre-Maq alignments for total RNA dataset / RNAseq to Ribosomal databases#####################################################
	for dbindex in range(0, int(no_predatabases)):
		database_name= predatabase[dbindex].strip()
		

		# Adding a Unique identifier
		pp1f1="/usr/local/jdk1.6.0_21/bin/javac -classpath . "
		pp1f1=pp1f1 + "UniqueIdentifier_premaq.java"
		p1f2=commands.getstatusoutput(pp1f1)
		print pp1f1
		
		#Unqiue idnetified 
		UNIQ="/usr/local/jdk1.6.0_21/bin/java -classpath . UniqueIdentifier_premaq /mnt/mfiles/reads/" + fFQ1
		UNIQ=UNIQ + " /mnt/mfiles/reads/"
		UNIQ=UNIQ + fFQ1
		UNIQ=UNIQ + ".tmp"
		p6=commands.getstatusoutput(UNIQ);
		print p6

		#RepeatMaskerFormat.java
		pp1f1="/usr/local/jdk1.6.0_21/bin/javac -classpath . "
		pp1f1=pp1f1 + "FQone2Fasta.java"
		p1f2=commands.getstatusoutput(pp1f1)
		print pp1f1

		
		# Convert Unmapped reads  FQ1 2 FASTA
		FQ12FASTA="/usr/local/jdk1.6.0_21/bin/java -classpath . FQone2Fasta /mnt/mfiles/reads/" + fFQ1
		FQ12FASTA=FQ12FASTA + ".tmp /mnt/mfiles/reads/"
		FQ12FASTA=FQ12FASTA + fFASTA
		FQ12FASTA=FQ12FASTA + " FQ1"
		p6=commands.getstatusoutput(FQ12FASTA);
		print p6
		
		if dbindex == 0:
			print "Already upload stats from duplicate remover"
		else :

			#AFTER MEGABLAST  - STATISTICS
			print "Statistics after Megablast"
			STAT1="/bin/grep \">\" /mnt/mfiles/reads/" + fFASTA
			STAT1=STAT1 + " | wc -l"
			STAT1=STAT1 + " > /mnt/mfiles/reads/"
			STAT1=STAT1 + sPreMaq
			STAT1=STAT1 + str(dbindex)
			STAT=commands.getstatusoutput(STAT1);
			print STAT

			#Upload the Statistics of reads After MEGABlast
			out1="/usr/bin/s3cmd -f -c /root/.s3cfg put /mnt/mfiles/reads/" + sPreMaq
			out1=out1 + str(dbindex)
			out1=out1 + " s3://"
			out1=out1 + stat
			out1=out1 + "/"
			print out1
			out=commands.getstatusoutput(out1)

		# Check No reads
		FQ12FASTA="/bin/grep \">\" /mnt/mfiles/reads/" + fFASTA
		FQ12FASTA=FQ12FASTA + " | wc -l"
		p6=commands.getstatusoutput(FQ12FASTA);
		print p6

		number_reads=int(p6[1])
		if number_reads == 0:
			break			
		
		# Megablast on reads over all.rnaAndCdna.fasta
		print "MEGABlast"
		mega1="/root/blast-2.2.23/bin/megablast -i /mnt/mfiles/reads/" + fFASTA	
		mega1=mega1 + " -d \"/mnt/mfiles/ref/"
		mega1=mega1 + database_name
		mega1=mega1 + "\" -m 7 -a 4 -D 2 -e 0.0000001 -W 16 -b 0 -v 1 -f -F F -o /mnt/mfiles/reads/"
		mega1=mega1 + fOUT
		print mega1
		p6=commands.getstatusoutput(mega1);
		print p6

		#Blastxml.java
		blastxml1="/usr/local/jdk1.6.0_21/bin/javac -classpath . "
		blastxml1=blastxml1 + "blastxml.java"
		blastxml=commands.getstatusoutput(blastxml1)
		print blastxml

		# Convert BLASTXML
		blastxml1="/usr/local/jdk1.6.0_21/bin/java -classpath . blastxml /mnt/mfiles/reads/" + fOUT
		blastxml1=blastxml1 + " /mnt/mfiles/reads/"
		blastxml1=blastxml1 + fOUT1
		blastxml=commands.getstatusoutput(blastxml1);
       		
		# g++ blastxml.cc
	        #CC1="/usr/bin/g++ blastxml.cc -o blastxml"
		#print CC1
		#p6=commands.getstatusoutput(CC1);
       		#print p6

	       	# Run Blastxml.cc
        	#CC1="./blastxml /mnt/mfiles/reads/" + fOUT
		#CC1=CC1 + " /mnt/mfiles/reads/"
		#CC1=CC1 + fOUT1
	        #p6=commands.getstatusoutput(CC1);
       		#print p6
		
		# Extract unmappeed reads from the blast hit
		SORT="/bin/sort +1 -0 /mnt/mfiles/reads/" + fOUT1
		SORT=SORT + " > /mnt/mfiles/reads/"
		SORT=SORT + fOUT1
		SORT=SORT + ".tmp"
		SORT1=commands.getstatusoutput(SORT)
		print SORT1

		#BlastParser.java
		pp1f1="/usr/local/jdk1.6.0_21/bin/javac -classpath . "
		pp1f1=pp1f1 + "extractUnmapped_Adapterblast.java"
		p1f2=commands.getstatusoutput(pp1f1)
		print pp1f1

		# Convert BLASTPARSER BLASTOUTPUT 2 OUTTMP
		BLASTP1="/usr/local/jdk1.6.0_21/bin/java -classpath . extractUnmapped_Adapterblast /mnt/mfiles/reads/" + fOUT1
		BLASTP1=BLASTP1 + ".tmp"
		BLASTP1=BLASTP1 + " 0.9 0.95 "
		BLASTP1=BLASTP1 + "/mnt/mfiles/reads/"
		BLASTP1=BLASTP1 + fFQ1
		BLASTP1=BLASTP1 + ".tmp /mnt/mfiles/reads/"
		BLASTP1=BLASTP1 + fFQ2
		BLASTP1=BLASTP1 + " /mnt/mfiles/reads/"
		BLASTP1=BLASTP1 + fFQ2
		BLASTP1=BLASTP1 + ".tmp"
		p6=commands.getstatusoutput(BLASTP1);
		print p6

		# Copy the fFQ2 to fFQ1 for next run
		CC1="/bin/cp /mnt/mfiles/reads/" + fFQ2
		CC1=CC1 + " /mnt/mfiles/reads/"
		CC1=CC1 + fFQ1
		p6=commands.getstatusoutput(CC1);
		print p6

#################################################################
        #STATISTICS - AFTER PREMAQ
        STAT1="/usr/bin/wc -l /mnt/mfiles/reads/" + fFQ1
	STAT1=STAT1 + " > /mnt/mfiles/reads/"
	STAT1=STAT1 + sPreMaq
	STAT1=STAT1 + str(no_predatabases)
        STAT=commands.getstatusoutput(STAT1);
        print STAT
			
	#Upload the Statistics of reads After MEGABlast
	out1="/usr/bin/s3cmd -f -c /root/.s3cfg put /mnt/mfiles/reads/" + sPreMaq
	out1=out1 + str(no_predatabases)
	out1=out1 + " s3://"
	out1=out1 + stat
	out1=out1 + "/"
	print out1
	out=commands.getstatusoutput(out1)

        
	#Step 1g. Convert FQ1 to FASTQ -compile
        FQ12FASTQ="/usr/local/jdk1.6.0_21/bin/javac -classpath . "
        FQ12FASTQ=FQ12FASTQ + "FQone2Fastq.java"
        FQ12FASTQc=commands.getstatusoutput(FQ12FASTQ)
        print FQ12FASTQc

        #Step1b. Convert FQ12FASTQ
        FQ12FASTQ="/usr/local/jdk1.6.0_21/bin/java -classpath . FQone2Fastq /mnt/mfiles/reads/" + fFQ1
        FQ12FASTQ=FQ12FASTQ + " /mnt/mfiles/reads/"
        FQ12FASTQ=FQ12FASTQ + fFASTQ
        FQ12FASTQc=commands.getstatusoutput(FQ12FASTQ);
        print FQ12FASTQc

############Running BWA alignments#####################################################
	for dbindex in range(0, int(no_bwadatabases)):
		database_name= bwadatabase[dbindex].strip()
		print database_name

		#Step 5a. Run the BWA alignment on each database
		BWA="/root/bwa-0.6.1/bwa aln /mnt/mfiles/ref/" + database_name
		BWA=BWA + " /mnt/mfiles/reads/"
		BWA=BWA + fFASTQ
		BWA=BWA + " > /mnt/mfiles/reads/"
		BWA=BWA + fOut
		print BWA
		BWAc=commands.getstatusoutput(BWA);
		print BWAc

		#Step 5b. Run the BWA alignment on each database
		BWA="/root/bwa-0.6.1/bwa samse /mnt/mfiles/ref/" + database_name
		BWA=BWA + " /mnt/mfiles/reads/"
		BWA=BWA + fOut
		BWA=BWA + " /mnt/mfiles/reads/"
		BWA=BWA + fFASTQ
		BWA=BWA + " > /mnt/mfiles/reads/"
		BWA=BWA + fQSAM
		print BWA
		BWAc=commands.getstatusoutput(BWA);
		print BWAc

		#Step 5b. compile MAQunmapped 2 FASTQ
		BWA2FASTQ="/usr/local/jdk1.6.0_21/bin/javac -classpath . "
		BWA2FASTQ=BWA2FASTQ + "BWAunmapped.java"
		BWA2FASTQc=commands.getstatusoutput(BWA2FASTQ)
		#print MAQ2FASTQc

		#Step 5c. Convert Unmapped reads MAQunmapped 2 FASTQ
		Un2FASTQ="/usr/local/jdk1.6.0_21/bin/java -classpath . BWAunmapped /mnt/mfiles/reads/" + fQSAM
		Un2FASTQ=Un2FASTQ + " /mnt/mfiles/reads/"
		Un2FASTQ=Un2FASTQ + fFASTQ
		print Un2FASTQ
		Un2FASTQc=commands.getstatusoutput(Un2FASTQ);
		print Un2FASTQc

		# compile Java files
		pp1f1="/usr/local/jdk1.6.0_21/bin/javac -classpath . "
		pp1f1=pp1f1 + "Fastq2FQone.java"
		p1f2=commands.getstatusoutput(pp1f1)
		print pp1f1
		
		# Convert Unmapped reads MAQunmapped 2 FQ1
		Un2FASTQ="/usr/local/jdk1.6.0_21/bin/java -classpath . Fastq2FQone /mnt/mfiles/reads/" + fFASTQ
		Un2FASTQ=Un2FASTQ + " /mnt/mfiles/reads/"
		Un2FASTQ=Un2FASTQ + fFQ1
		print Un2FASTQ
		p6=commands.getstatusoutput(Un2FASTQ);
		print p6		

		#STATISTICS - AFTER DB1
		STAT1="/usr/bin/wc -l /mnt/mfiles/reads/" + fFQ1
		STAT1=STAT1 + " > /mnt/mfiles/reads/"
		STAT1=STAT1 + bDB
		STAT1=STAT1 + str((dbindex+1))
		STAT=commands.getstatusoutput(STAT1);
		print STAT

		#Upload the Statistics of reads after DB1
		out1="/usr/bin/s3cmd -f -c /root/.s3cfg put /mnt/mfiles/reads/" + bDB
		out1=out1 + str((dbindex+1))
		out1=out1 + " s3://"
		out1=out1 + stat
		out1=out1 + "/"	
		print out1
		out=commands.getstatusoutput(out1)


#################################################################
        
	#Upload the unmapped reads
        #out1="/usr/bin/s3cmd -f -c /root/.s3cfg put /mnt/mfiles/reads/" + fFQ1
        #out1=out1 + " s3://"
	#out1=out1 + output
	#out1=out1 + "/"
        #print out1
        #out=commands.getstatusoutput(out1)

############Running Maq alignments#####################################################
	for dbindex in range(0, int(no_databases)):
		database_name= database[dbindex].strip()
		
		#Step 4: FASTQ to BFQ
		FASTQ2BFQ="/usr/local/bin/maq fastq2bfq /mnt/mfiles/reads/" + fFASTQ
		FASTQ2BFQ=FASTQ2BFQ + " /mnt/mfiles/reads/"
		FASTQ2BFQ=FASTQ2BFQ + fBFQ
		FASTQ2BFQc=commands.getstatusoutput(FASTQ2BFQ)
		print FASTQ2BFQc

		#Step 5 : Blast against databases

		#Step 5a. Run the MAQ alignment on each database
		MAQ="/usr/local/bin/maq map -u /mnt/mfiles/reads/" + fUmap
		MAQ=MAQ + " /mnt/mfiles/reads/"
		MAQ=MAQ + fOut
		MAQ=MAQ + " /mnt/mfiles/ref/"
		MAQ=MAQ + database_name
		MAQ=MAQ + " /mnt/mfiles/reads/"
		MAQ=MAQ + fBFQ
		MAQc=commands.getstatusoutput(MAQ);
		#print maq

		#Step 5b. compile MAQunmapped 2 FASTQ
		MAQ2FASTQ="/usr/local/jdk1.6.0_21/bin/javac -classpath . "
		MAQ2FASTQ=MAQ2FASTQ + "MAQunmapped2fastq.java"
		MAQ2FASTQc=commands.getstatusoutput(MAQ2FASTQ)
		#print MAQ2FASTQc

		#Step 5c. Convert Unmapped reads MAQunmapped 2 FASTQ
		Un2FASTQ="/usr/local/jdk1.6.0_21/bin/java -classpath . MAQunmapped2fastq /mnt/mfiles/reads/" + fUmap
		Un2FASTQ=Un2FASTQ + " /mnt/mfiles/reads/"
		Un2FASTQ=Un2FASTQ + fFASTQ
		Un2FASTQc=commands.getstatusoutput(Un2FASTQ);
		print Un2FASTQc

		# compile Java files
		pp1f1="/usr/local/jdk1.6.0_21/bin/javac -classpath . "
		pp1f1=pp1f1 + "MAQunmapped2FQone.java"
		p1f2=commands.getstatusoutput(pp1f1)
		print pp1f1
		
		# Convert Unmapped reads MAQunmapped 2 FQ1
		Un2FASTQ="/usr/local/jdk1.6.0_21/bin/java -classpath . MAQunmapped2FQone /mnt/mfiles/reads/" + fUmap
		Un2FASTQ=Un2FASTQ + " /mnt/mfiles/reads/"
		Un2FASTQ=Un2FASTQ + fFQ1
		p6=commands.getstatusoutput(Un2FASTQ);
		print p6		

		#STATISTICS - AFTER DB1
		STAT1="/usr/bin/wc -l /mnt/mfiles/reads/" + fFQ1
		STAT1=STAT1 + " > /mnt/mfiles/reads/"
		STAT1=STAT1 + sDB
		STAT1=STAT1 + str((dbindex+1))
		STAT=commands.getstatusoutput(STAT1);
		print STAT

		#Upload the Statistics of reads after DB1
		out1="/usr/bin/s3cmd -f -c /root/.s3cfg put /mnt/mfiles/reads/" + sDB
		out1=out1 + str((dbindex+1))
		out1=out1 + " s3://"
		out1=out1 + stat
		out1=out1 + "/"	
		print out1
		out=commands.getstatusoutput(out1)


#################################################################
        
	#Upload the unmapped reads
        out1="/usr/bin/s3cmd -f -c /root/.s3cfg put /mnt/mfiles/reads/" + fFQ1
        out1=out1 + " s3://"
	out1=out1 + output
	out1=out1 + "/"
        print out1
        out=commands.getstatusoutput(out1)
