/*
 * Author: Aleksandar D. Kostic
 * Date: 9-20-09
 * Usage: 
 * Updated: 
 * Details: Converts a MAQ unmapped read file (one-line per read) into FQ1 format (one line per read).
 */


import java.io.*;


public class MAQunmapped2FQone {
	
	private static String caller= "MAQunmapped2FQone ";

	public static void main(String args[]) throws FileNotFoundException {

		String inputFile=  args[0]; 
		String outputFile= args[1];



		long start = System.currentTimeMillis();

		int seqCounter = 0;

		try{
			BufferedWriter out = new BufferedWriter(new FileWriter(outputFile));
			FileReader fr1=new FileReader(inputFile);
			BufferedReader br=new BufferedReader(fr1);
			
			
			String strLine;

			while ((strLine = br.readLine()) != null)   {
				seqCounter++;
				String[] column= strLine.split("\t");
				out.write(  "@" + column[0] + "\t" + 
							column[2] + "\t" +
							"+" + "\t" + 
							column[3] + "\n");
			}
			long elapsedTimeMillis = System.currentTimeMillis()-start;
			float elapsedTimeSec = elapsedTimeMillis/1000F;
			System.out.println(seqCounter+" reads in this dataset."+"  Amount of time: "+elapsedTimeSec);

			fr1.close();
			out.flush();
			out.close();
		}catch (Exception e){//Catch exception if any
			System.err.println("Error: " + e.getMessage());
		}
	}
	public static String getCaller() {
		return caller;
	}
}
