#!/usr/bin/env python
# Created: Chandra Sekhar Pedamallu, DFCI
# Purpose: After Duplicate remover redistribute for Repeat masker
# DFCI @ copyright

import sys
import os
import commands
import random

hadooploc="/usr/local/hadoop-1.0.3"
output=""
stat=""
rinput=""
ccount=0
nclus=20
for arg in sys.argv:
	if ccount==1:
		rinput=arg
	elif ccount==2:
		stat=arg
	elif ccount==3:
		output=arg
	elif ccount==4:
		nclus=int(arg)

	ccount=ccount+1

print rinput

nfolder=rinput

nnFILE=".fq1." + rinput
nnFILE1=rinput + ".fq1"
nnFILE2=rinput + "u.fq1"
nnFILE11=rinput + "sort.fq1"

sBRP="totalreads.stat.BREPBDUP"  # Before repeatmasker and before Duplicate
sBRP1="totalreads.stat.BREPADUP" # Before repeatmasker and after Duplicate


mkdir1="/bin/mkdir /mnt/mfiles/" + nfolder
mkdir=commands.getstatusoutput(mkdir1)
print mkdir

wget1="/usr/bin/s3cmd -f -c /root/.s3cfg ls s3://"
wget1=wget1 + output
wget1=wget1 + " | awk '{print \"/usr/bin/s3cmd -f -c /root/.s3cfg get \"$4\" "
wget1=wget1 + "/mnt/mfiles/"
wget1=wget1 + nfolder
wget1=wget1 + "\""
wget1=wget1 + ";}' > /mnt/mfiles/repeat.cmd"
print wget1
wget=commands.getstatusoutput(wget1)

wget=commands.getstatusoutput("chmod 777 -R /mnt/mfiles/repeat.cmd")
wget=commands.getstatusoutput("/mnt/mfiles/repeat.cmd")

print "concat"
# Concat all files downloaded into a temporary file
cat1="/usr/bin/find /mnt/mfiles/" + nfolder
cat1=cat1 + "/ -name \"*.fq1\" -print | xargs cat >> /mnt/mfiles/"
cat1=cat1 + nfolder
cat1=cat1 + "/"
cat1=cat1 + nnFILE
print cat1
wget=commands.getstatusoutput(cat1)
print wget
#find /mnt/mfiles/ami-ami-ccgdlane82-repeato/ -name "*.fq1" | xargs rm

# remove all files except temporary file
cat1="/usr/bin/find /mnt/mfiles/" + nfolder
cat1=cat1 + "/ -name \"*.fq1\" | xargs rm"
print cat1
wget=commands.getstatusoutput(cat1)
print wget

# move temp. file into FQ1
cat1="/bin/mv /mnt/mfiles/" + nfolder
cat1=cat1 + "/"
cat1=cat1 + nnFILE
cat1=cat1 + " /mnt/mfiles/"
cat1=cat1 + nfolder
cat1=cat1 + "/"
cat1=cat1 + nnFILE1
wget=commands.getstatusoutput(cat1)

#Total reads before repeatmasker - STATISTICS
print "Statistics before repeatmasker"
STAT1="/usr/bin/wc -l /mnt/mfiles/" + nfolder
STAT1=STAT1 + "/"
STAT1=STAT1 + nnFILE1
STAT1=STAT1 + " > /mnt/mfiles/reads/"
STAT1=STAT1 + sBRP
STAT=commands.getstatusoutput(STAT1);
print STAT

#Upload the Statistics of reads before repeatmasker
out1="/usr/bin/s3cmd -f -c /root/.s3cfg put /mnt/mfiles/reads/" + sBRP
out1=out1 + " s3://"
out1=out1 + stat
out1=out1 + "/"
print out1
out=commands.getstatusoutput(out1)

#Step1c. Sorting the FQ1 file
print "SORTING"
SORT1="/bin/sort +1 -2 -T /mnt/mfiles /mnt/mfiles/" + nfolder
SORT1=SORT1 + "/"
SORT1=SORT1 + nnFILE1
SORT1=SORT1 + " > /mnt/mfiles/"
SORT1=SORT1 + nfolder
SORT1=SORT1 + "/"
SORT1=SORT1 + nnFILE11
SORT=commands.getstatusoutput(SORT1);
print SORT

#Step1d. Duplicate remover
DUP1="/usr/local/jdk1.6.0_21/bin/javac -classpath /root/ "
DUP1=DUP1 + "*.java"
DUP=commands.getstatusoutput(DUP1);
print DUP

#Step1e. Run duplicate remover
DUP1="/usr/local/jdk1.6.0_21/bin/java -classpath /root/ removeduplicates_new /mnt/mfiles/" + nfolder
DUP1=DUP1 + "/"
DUP1=DUP1 + nnFILE11
DUP1=DUP1 + " /mnt/mfiles/"
DUP1=DUP1 + nfolder
DUP1=DUP1 + "/"
DUP1=DUP1 + nnFILE1
print DUP1
DUP=commands.getstatusoutput(DUP1);
print DUP
print "completed"

#Step1e. Add an identfier at the end of the read
pp1f1="/usr/local/jdk1.6.0_21/bin/javac -classpath /root/ "
pp1f1=pp1f1 + "*.java"
p1f2=commands.getstatusoutput(pp1f1)

ident="/usr/local/jdk1.6.0_21/bin/java -classpath /root/ UniqueIdentifier /mnt/mfiles/" + nfolder
ident=ident + "/" 
ident=ident + nnFILE1
ident=ident + " /mnt/mfiles/"
ident=ident + nfolder
ident=ident + "/"
ident=ident + nnFILE2
p6=commands.getstatusoutput(ident);
print p6

cat1="/bin/mv /mnt/mfiles/" + nfolder
cat1=cat1 + "/"
cat1=cat1 + nnFILE2
cat1=cat1 + " /mnt/mfiles/"
cat1=cat1 + nfolder
cat1=cat1 + "/"
cat1=cat1 + nnFILE1
mvf=commands.getstatusoutput(cat1)


#STATISTICS - AFTER DUPLICATE REMOVER
STAT1="/usr/bin/wc -l /mnt/mfiles/" + nfolder
STAT1=STAT1 + "/"
STAT1=STAT1 + nnFILE1
STAT1=STAT1 + " > /mnt/mfiles/reads/"
STAT1=STAT1 + sBRP1
STAT=commands.getstatusoutput(STAT1);
print STAT

#Upload the Statistics of reads after duplicate remover
out1="/usr/bin/s3cmd -f -c /root/.s3cfg put /mnt/mfiles/reads/" + sBRP1
out1=out1 + " s3://"
out1=out1 + stat
out1=out1 + "/"
print out1
out=commands.getstatusoutput(out1)

# remove all files except temporary file
cat1="/bin/rm -f /mnt/mfiles/" + nfolder
cat1=cat1 + "/"
cat1=cat1 + nnFILE11
wget=commands.getstatusoutput(cat1)


#Divide into chunks of 100K sequences
pp1f1="/usr/local/jdk1.6.0_21/bin/javac -classpath /root/ "
pp1f1=pp1f1 + "*.java"
p1f2=commands.getstatusoutput(pp1f1)
print pp1f1

# Number FQ1
NFQ1="/usr/bin/wc -l < /mnt/mfiles/" + nfolder
NFQ1=NFQ1 + "/"
NFQ1=NFQ1 + nnFILE1
NFQ=commands.getstatusoutput(NFQ1);

nlineFQ1 = int(NFQ[1])
nChunk=str(10000)

if nlineFQ1 > 600000:
	#nChunk1=int(nlineFQ1/10000) + 1
	nChunk=str("10000")
else:
	nChunk1=int(nlineFQ1/(nclus*3)) + 1
	nChunk=str(nChunk1)

print nChunk

# CHUNK CREATER
CHUNK="/usr/local/jdk1.6.0_21/bin/java -classpath /root/ FileSplitter_S3bucket /mnt/mfiles/" + nfolder
CHUNK=CHUNK + "/" 
CHUNK=CHUNK + nnFILE1
#CHUNK=CHUNK + " 10000 "
CHUNK=CHUNK + " "
CHUNK=CHUNK + nChunk
CHUNK=CHUNK + " "
CHUNK=CHUNK + nnFILE1
CHUNK=CHUNK + " NONE "
CHUNK=CHUNK + rinput
print CHUNK
p6=commands.getstatusoutput(CHUNK);
print p6
no_files=int(p6[1])
 
# remove concated files
cat1="/bin/rm -f /mnt/mfiles/" + nfolder
cat1=cat1 + "/"
cat1=cat1 + nnFILE1
wget=commands.getstatusoutput(cat1)

#Upload manifest files to Hadoop <repeatman>
out1=hadooploc + "/bin/hadoop fs -mkdir repeatman"
out=commands.getstatusoutput(out1)

i_no=0
for i_no in range(no_files):
	fileno=i_no + 1

	#Upload fq1 files to S3 Bucket
	out1="/usr/bin/s3cmd -f -c /root/.s3cfg put -r /mnt/mfiles/" + nfolder
	out1=out1 + "/*_"
	out1=out1 + str(fileno)
	out1=out1 + "_*.fq1 "
	out1=out1 + "s3://"
	out1=out1 + rinput
	out1=out1 + "/"
	print out1
	out=commands.getstatusoutput(out1)

	#Upload man files to S3 Bucket
	out1=hadooploc + "/bin/hadoop fs -put /mnt/mfiles/" 
	out1=out1 + nfolder
	out1=out1 + "/*_"
	out1=out1 + str(fileno)
	out1=out1 + "_*.man repeatman"
	print out1
	out=commands.getstatusoutput(out1)

# remove all files
cat1="/bin/rm -r /mnt/mfiles/" + nfolder
wget=commands.getstatusoutput(cat1)
